package cz.xelfi.feedbook;

import com.google.code.facebookapi.FacebookException;
import com.google.code.facebookapi.FacebookJaxbRestClient;
import com.google.code.facebookapi.Permission;
import com.sun.syndication.feed.rss.Channel;
import com.sun.syndication.feed.rss.Item;
import com.sun.syndication.io.WireFeedInput;
import java.awt.Desktop;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.util.prefs.Preferences;
import org.xml.sax.InputSource;

public class Main {
    private static String APP_KEY;
    private static String APP_SEC;
    private static String APP_FEED;
    
    
    private static String login() throws IOException, FacebookException, URISyntaxException {
        FacebookJaxbRestClient login = new FacebookJaxbRestClient(APP_KEY, APP_SEC);
        final String token = login.auth_createToken();
        URI u = new URI("http://www.facebook.com/login.php?api_key=" + APP_KEY + "&auth_token=" + token);
        String msg = "authentication";
        browser(msg, u);
        return login.auth_getSession(token, false); 
    }

    private static void browser(String msg, URI u) throws IOException {
        System.out.println(msg + ": " + u);
        try {
            Desktop.getDesktop().browse(u);
        } catch (Exception ex) {
            Runtime.getRuntime().exec("xdg-open " + u);
        }
        System.out.println("Visit the browser and press enter...");
        System.in.read();
    }
    
    public static void main( String[] args) throws Exception {
        Preferences prefs = Preferences.userNodeForPackage(Main.class);
        if (args.length == 3) {
            prefs.put("id", args[0]);
            prefs.put("secret", args[1]);
            prefs.put("feed", args[2]);
        } else {
            if (args.length != 0) {
                usage();
                return;
            }
        }
        
        
        APP_KEY = prefs.get("id", null);
        APP_SEC = prefs.get("secret", null);
        APP_FEED = prefs.get("feed", null);
        
        if (APP_FEED == null || APP_SEC == null || APP_KEY == null) {
            usage();
            return;
        }
        
        WireFeedInput rssInput = new WireFeedInput();
        URL rssUrl = new URL(APP_FEED);
        Channel rss = (Channel)rssInput.build(new InputSource(rssUrl.openStream()));;
        
        
        FacebookJaxbRestClient fb;
        Long user;
        for (;;) {
            final String stored = prefs.get("session", null);
            if (stored != null) {
                try {
                    fb = new FacebookJaxbRestClient(APP_KEY, APP_SEC, stored);
                    user = fb.users_getLoggedInUser();
                    break;
                } catch (FacebookException ex) {
                    System.err.println(ex.getMessage());
                }
            }
            final String session = login();
            fb = new FacebookJaxbRestClient(APP_KEY, APP_SEC, session);
            user = fb.users_getLoggedInUser();
            prefs.put("session", session);
            break;
        }
        
        while (!fb.users_hasAppPermission(Permission.SHARE_ITEM)) {
            URI u = new URI("https://graph.facebook.com/oauth/authorize?"
                    + "client_id=" + APP_KEY
                    + "&redirect_uri=http://www.facebook.com/connect/login_success.html"
                    + "&scope=publish_stream");
            browser("Need permission to publish links", u);
        }
        Preferences n = prefs.node("feeds");
        int cnt = 0;
        for (Object o : rss.getItems()) {
            Item item = (Item) o;
            String hex = Integer.toHexString(item.getLink().hashCode());
            if (n.getLong(hex, -1L) != -1L) {
                continue;
            }
            cnt++;
            System.out.printf("link: %s date: %s title: %s\n", item.getLink(), item.getPubDate(), item.getTitle());
            Long ok = fb.links_post(user, item.getLink(), item.getTitle());
            System.out.println("posted as " + ok);
            n.putLong(hex, ok);
            n.put(hex + ".url", item.getLink());
        }
        System.out.println("Published " + cnt + " feed item(s)");
    }

    private static void usage() {
        System.out.println("Invoke with three parameters: "
                + "<facebook_app_key> "
                + "<facebook_app_secret "
                + "<rss_feed_url>");
    }
}
